con
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  XTiles = 8
  YTiles = 6
  xpix = xtiles * 16 - 1
  ypix = ytiles * 16 - 1
  paramcount = 21

  Bitmapp = $7400
  DBuff = $6800
  _free = $2000 >> 2

  KUp = 194
  KDn = 195
  KH  = 193
  KV  = 192

  MBL = 6
  
obj
  vga : "VGA"
  gr : "Graphics"
  key : "Keyboard"
  nrs : "Simple_Numbers"
  minne : "minne"
  'mus : "FalldownMusic"
var
  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_hd        'horizontal display ticks           write-only
  long  tv_hf        'horizontal front porch ticks       write-only
  long  tv_hs        'horizontal sync ticks              write-only
  long  tv_hb        'horizontal back porch ticks        write-only
  long  tv_vd        'vertical display lines             write-only
  long  tv_vf        'vertical front porch lines         write-only
  long  tv_vs         'vertical sync lines                write-only
  long  tv_vb        'vertical back porch lines          write-only
  long  tv_rate      'tick rate (Hz)                     write-only

'  long  tv_broadcast  'broadcast frequency (Hz)                write-only
'  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[xtiles * ytiles]
  long  colors[2]
  byte players
  long seed

  byte P1
  byte P1C
  byte P1F
  byte P1D
  byte P2
  byte P2C
  byte P2F
  byte P2D

  byte P1B[3]
  byte P2B[3]
  byte ball[3]
pub Main | i,tx,ty
  key.start(26,27)
  longmove (@tv_status,@tvparams, paramcount)
  tv_screen := @screen
  tv_colors := @colors
  tv_rate := clkfreq >> 2    'freq
  tv_hx := scx
  tv_vx := scy
  vga.start(@tv_status)
  'repeat i from 0 to 63
  '  colors[i] := %%3000_0300_0030_0000
  minne.start
  repeat tx from 0 to xtiles - 1
    repeat ty from 0 to ytiles - 1 
      'screen[(ty - 1) * xtiles + tx] := (@bitmapp) >> 6 + tx * ytiles + ty + (1 << 10)
      screen[ty * xtiles + tx] := (bitmapp ) >> 6 + tx * ytiles + ty + (1 << 10)
  colors[0] := %%3000_3330_0030_1110
  colors[1] := %%3000_3330_0030_0000
  gr.start
  gr.setup(xtiles,ytiles,0,0,dbuff)
  gr.pix(0,0,0,@splash)
  gr.copy(bitmapp)
  waitcnt(cnt + clkfreq * 3)
  if key.present == 0
    gr.clear
    gr.color(3)
    gr.text(0,ypix - 16,string("No keyboard!"))
    gr.copy(bitmapp)
    return
  players := 1
  repeat
    i := menu(1)
    if i == 1
      presentwinner(rungame(players,byte[@lvlnr] - "1"))
    if i == 3
      repeat until i == 5
        i := menu(2)
        if i == 2
          ChSi
        if i == 1
          ChSp
        if i == 4
          saveeeprom
        if i == 3
          ChScrS

pri ChScrS|i
  gr.clear
  gr.textmode(1,1,6,%101)
  gr.text(xpix / 2,ypix / 2,string("Use arrows to change."))
  gr.text(xpix / 2,ypix / 2 - 16,string("d = defalut"))
  gr.copy(bitmapp)  
  repeat until i == 13
    i := key.getkey
    if i == kup
      scy++
      if scy > 5
        scy := 5
    if i == kdn
      if scy > 1
        scy--
    if i == kh
      scx++
      if scx > 5
        scx := 5
    if i == kv
      if scx > 1
        scx--
    if i == "D" or i == "d"
      scx := 1
      scy := 1
    tv_hx := scx
    tv_vx := scy
pri ChSp|i, y, t, d
  colors[1] := %%3000_3330_0300_0000
  y := 4
  d := 1
  gr.clear
  gr.text(0,ypix- 16,string("Select speed"))
  gr.text(0,ypix - 32,string("d = defalut"))
  repeat until i == 13
    t := cnt
    i := key.key
    gr.color(1)
    gr.pix(xpix - 5,y,0,@boll)
    if i == kup
      gspeed++
      if gspeed > 150
        gspeed := 150
    if i == kdn
      gspeed--
      if gspeed < 40
        gspeed := 40
    if i == "D" or i == "d"
      gspeed := 80
    if d== 1
      y ++
      if y > ypix - 4
        d := 2
    if d == 2
      y--
      if y < 4
        d := 1
    gr.color(3)
    gr.plot(0,0)
    gr.line(110,0)
    gr.color(1)
    gr.plot(0,0)
    gr.line(gspeed - 40,0)
    gr.copy(bitmapp)
    gr.color(0)
    gr.quad(xpix,ypix,xpix - 10,ypix,xpix - 10,0,xpix,0)
    waitcnt(t + clkfreq / gspeed)
pri ChSi|i
  p2 :=0
  colors[1] := %%3000_3330_0300_0000
  repeat until i == 13
    gr.clear
    gr.color(1)
    gr.text(10,ypix - 16,string("Select size"))
    gr.text(10,ypix - 32,string("d = defalut"))
    gr.color(2)
    gr.quad(2,p2,2,p2 + PaddleHeight,4,p2+Paddleheight,4,p2)
    gr.copy(bitmapp)
    i := key.getkey
    if i == kup
      paddleheight++
    if i == kdn
      paddleheight--
    if i == "d" or i == "D"
      paddleheight := 19
    if paddleheight < 10
      paddleheight := 10
    if paddleheight > 40
      paddleheight := 40
pri SaveEEPROM | i, OK, t, g
  gr.clear
  gr.color(3)
  gr.text(0,ypix - 16,string("Do you want to save?"))
  gr.text(0,ypix - 32,string("All data on locations"))
  gr.text(0,ypix - 48,nrs.hex(@gspeed,4))
  gr.text(30,ypix - 48,string("-"))
  gr.text(40,ypix - 48,nrs.hex(@scy,4))
  gr.text(0,ypix - 64,string("will be deleted."))
  gr.text(0,ypix - 80,string("Continue? Y/N"))
  gr.copy(bitmapp)
  g:=0
  repeat while g == 0
    t := key.getkey
    if t == "Y" or t == "y"
      g := 1
    if t == "N" or t == "n"
      g := 2
  if g == 2
    return
  gr.clear
  gr.color(2)
  gr.textmode(1,1,6,0)
  gr.text(0, ypix - 16,string("Saving..."))
  repeat i from @gspeed to @scy
    minne.writeEEPROM(28 << 18 | i,i,1)
    gr.plot(0,0)
    gr.line(xpix / 4 * ((i+1) - @gspeed),0)
    gr.plot(0,1)
    gr.line(xpix / 4 * ((i+1) - @gspeed),1)
    gr.plot(0,2)
    gr.line(xpix / 4 * ((i+1) - @gspeed),2)
    gr.copy(bitmapp)
    minne.readEEPROM(28 << 18 | i,i,1)
    waitcnt(cnt + clkfreq / 10)
  'gr.color(0)
  'gr.quad(0,0,0,2,xpix,2,xpix,0)
  'gr.copy(bitmapp)
  'gr.color(2)
  'i := 0
  'repeat i from 0 to 5 * 10
  '  minne.writeEEPROM(28 << 18 | @hsn[i],@hsn[i],1)
  '  gr.plot(0,0)
  '  gr.line((xpix / (5 * 10)) * (i+1),0)
  '  gr.plot(0,1)
  '  gr.line((xpix / (5 * 10)) * (i+1),1)
  '  gr.plot(0,2)
  '  gr.line((xpix / (5 * 10)) * (i+1),2)
  '  gr.copy(bitmapp)
  '  minne.readEEPROM(28 << 18 | @hsn[i],@hsn[i],1)
  '  waitcnt(cnt + clkfreq / 10)   
pri PresentWinner(winn)|t, addr
  waitcnt(cnt + clkfreq)
  byte[@winnernr] := winn + "0"
  addr := @winner
  if players == 1
    if winn == 1
      addr := @youwinner
    else
      addr := @cpuwinner  
  repeat t from 40 to 2
    gr.clear
    gr.color(1)
    gr.textmode(t / 2,t,6,%101)
    gr.text(xpix/2,ypix/2,addr)
    gr.copy(bitmapp)
    waitcnt(cnt + clkfreq / 10)
  key.clearkeys
  repeat until key.getkey == 13
    
pri menu(me) : doThis | i,strptr, total
  dothis := 1
  gr.textmode(1,1,6,0)
  key.clearkeys
  colors[1] := %%3000_0300_0030_0000
  total := lookup(me: 3,5)
  repeat
    gr.clear
    repeat i from 1 to total
      if me == 1
        if players == 1
          strptr := lookup(i: @ply,@lvl,@sett)
        else
          strptr := lookup(i: @pl2p, @lvl, @sett)
      elseif me == 2
        strptr := lookup(i: @chspeed, @chsze,@scrsze,@save,@back)        
      if i == dothis
        gr.color(1)
      else
        gr.color(2)
      gr.text(5,(total -i) * 16,strptr)
    gr.copy(bitmapp)
    i := key.getkey
    if i == kup
      dothis--
    if i == kdn
      dothis++
    if i == kh and dothis == 1 and me == 1
      players ++
      if players > 2
        players := 2
    if i == kv and dothis == 1 and me == 1
      players --
      if players < 1
        players := 1
    if i == kh and dothis == 2 and me == 1
      byte[@lvlnr]++
      if byte[@lvlnr] > "5"
        byte[@lvlnr] := "5"
    if i == kv and dothis == 2  and me == 1
      byte[@lvlnr]--
      if byte[@lvlnr] < "1"
        byte[@lvlnr] := "1"
    if i == 13
      return dothis
    if dothis > total
      dothis := total
    if dothis < 1
      dothis := 1
pri AI(Skill)
  case skill
    0:
      if p2b[0] == 0
        if (?seed >> 16) < $F
          shoot
      if ball[0] == 3 or ball[0] == 4
        if (?seed >> 16) < $68FF
          if ball[2] > p2 + paddleheight / 2
            'if (?seed >> 16) > $FF
            '  mup(1)
            'else
              mup(2)
          else
            'if (?seed >> 16) > $FF
            '  mdn(1)
            'else
              mdn(2)
    1:
      if p2b[0] == 0
        if (?seed >> 16) < $8F
          shoot
      if ball[0] == 3 or ball[0] == 4
        if (?seed >> 16) < $80FF
          if ball[2] > p2 + paddleheight / 2
            if (?seed >> 16) < $6FFF
              mup(1)
            else
              mup(2)
          else
            if (?seed >> 16) < $6FFF
              mdn(1)
            else
              mdn(2)
    2:
      if p2b[0] == 0
        if (?seed >> 16) < $FF
          shoot
      if ball[0] == 3 or ball[0] == 4
        if (?seed >> 16) < $90FF
          if ball[2] > p2 + paddleheight / 2
            if (?seed >> 16) < $5EFF
              mup(1)
            else
              mup(2)
          else
            if (?seed >> 16) < $5EFF
              mdn(1)
            else
              mdn(2)

    3:
      if p2b[0] == 0
        if (?seed >> 16) < $8FF
          shoot
      if ball[0] == 3 or ball[0] == 4
        if (?seed >> 16) < $88FF
          if ball[2] > p2 + paddleheight / 2
            'if (?seed >> 16) > $FF
            '  mup(1)
            'else
              mup(2)
          else
            'if (?seed >> 16) > $FF
            '  mdn(1)
            'else
              mdn(2)
    4:
      if ball[0] == 1 or ball[0] == 2
        
        if p1 > p2
          mdn(1)
        else
          mup(1)
        'if p1 + 5 > p2 and p1 - 5 < p2
        shoot
      else
        if ball[2] > p2 + paddleheight / 2
          mup(2)
        else
          mdn(2)
          
    '5:
    '  shoot
    '  if ball[2] < paddleheight / 2
    '    p2 := 0
    '  elseif ball[2] > ypix - (paddleheight / 2) - 3
    '    p2 := ypix - paddleheight - 3
    '  else
    '    p2 := ball[2] - (paddleheight / 2)
pri shoot
  if p2b[0] == 0
    p2b[0] := 1
    p2b[1] := 4
    p2b[2] := p2 + paddleheight / 2

pri MUp(speed)
  if p2c == 0
    p2+=speed
    if p2 >ypix - paddleheight - 3
      p2 := ypix - paddleheight - 3
  
pri MDn(speed) 
  if p2c == 0
    if p2 > speed - 1
      p2-= speed
    else
      p2 := 0   
pri rungame(nplayers, cpuskill) | rg, tc, tex,te2,sp
  'init game
  p1 := 0
  p1c := 1
  p1f := xpix >> 1 - 1
  p2 := 0
  p2c := 1
  p2f := xpix >> 1 - 1
  p1b[0] := 0
  p2b[0] := 0
  rg := 1
  tex := charsze
  te2 := 3
  sp := 15
  colors[0] := %%3000_3330_0030_1110
  colors[1] := %%3000_3330_0300_0000
  ball[0] := 0

  'run game
  repeat while rg == 1
    tc := cnt
    if nplayers == 2
      if key.keystate("q") and p2c == 0
        p2+=2
        if p2 >ypix - paddleheight - 3
          p2 := ypix - paddleheight - 3
      if key.keystate("a") and p2c == 0
        if p2 > 1
          p2-= 2
        else
          p2 := 0
      if key.keystate($20) and p2c == 0 'space
        if p2b[0] == 0 and p2d == 1
          p2d := 0
          p2b[0] := 1
          p2b[1] := 4
          p2b[2] := p2 + paddleheight / 2
      else
        if p2b[0] == 0
          p2d := 1
    else
      ai(cpuskill)
    if key.keystate(kup) and p1c == 0
      p1+=2
      if p1 > ypix - PaddleHeight - 3
        p1 := ypix - paddleheight - 3
    if key.keystate(kdn) and p1c == 0
      if p1 > 1
        p1-=2
      else
        p1 := 0
    if key.keystate($F3) and p1c == 0 'right ctrl
      if p1b[0] == 0 and p1d == 1
        p1d := 0
        p1b[0] := 1
        p1b[1] := xpix - 4
        p1b[2] := p1 + paddleheight / 2
    else
      if p1b[0] == 0
        p1d := 1
    gr.clear
    gr.color(3)
    gr.plot(0,ypix)
    gr.line(xpix,ypix)
    gr.plot(0,ypix - 1)
    gr.line(xpix,ypix - 1)
    gr.plot(0,ypix - 2)
    gr.line(xpix,ypix - 2)
    gr.color(1)
    'P2
    gr.quad(0,ypix,p2f,ypix,p2f,ypix - 2,0,ypix - 2)
    'P1
    gr.quad(xpix,ypix,xpix - p1f,ypix,xpix - p1f,ypix - 2,xpix,ypix - 2)
    'gr.color(3)
    'gr.plot(0,ypix - 2)
    'gr.line(xpix,ypix - 2)
    gr.color(2)
    gr.plot(xpix >> 1,ypix)
    gr.line(xpix >> 1,ypix - 2)
    gr.plot(xpix >> 1 + 1,ypix)
    gr.line(xpix >> 1 + 1,ypix - 2)
    
    if p2c > 0
      gr.quad(0,p2,0,p2 + PaddleHeight,2,p2+Paddleheight,2,p2)
      p2c--
    else
      gr.quad(2,p2,2,p2 + PaddleHeight,4,p2+Paddleheight,4,p2)
    if p1c > 0
      gr.quad(xpix,p1,xpix,p1 + paddleheight,xpix - 2,p1 + paddleheight,xpix - 2,p1)
      p1c--
    else
      gr.quad(xpix - 2,p1,xpix-2,p1 + paddleheight,xpix - 4,p1 + paddleheight,xpix - 4,p1)
    if p1b[0] == 1
      p1b[1]--            
      gr.pix(p1b[1],p1b[2],0,@RBoll)
      if p1b[1] == 0
        p1b[0] := 0
      if p1b[1] == 4
        if p1b[2] < p2 + paddleheight + 4 and p1b[2] > p2 - 4
          p1b[0] := 0
          p2c := DisableTime
      if p2b[1] > p1b[1] - 2 and p2b[1] < p1b[1] + 2
        if p2b[2] < p1b[2] + 8 and p2b[2] > p1b[2] - 8
          if p2b[0] == 1
            p2b[0] := 0
            p1b[0] := 0
    if p2b[0] == 1
      p2b[1]++
      gr.pix(p2b[1],p2b[2],0,@rboll)
      if p2b[1] == xpix
        p2b[0] := 0
      if p2b[1] == xpix - 4
        if p2b[2] < p1 + paddleheight + 4 and p2b[2] > p1 - 4
          p2b[0] := 0
          p1c := DisableTime
    if ball[0] == 0
      ball[0] := (?seed >> 16) * 4 / $FFFF
      ball[1] := xpix >> 1
      ball[2] := (?seed >> 16) * (ypix - 3) / $FFFF
    else
      case ball[0]
        1:
          ball[1]++
          ball[2]++
        2:
          ball[1]++
          ball[2]--
        3:
          ball[1]--
          ball[2]--
        4:
          ball[1]--
          ball[2]++
      if ball[1] < 4
        ball[0] := 0
        p2f -= ForceLoss
      if ball[1] < 8 and p2 < ball[2] + 4 and p2 + paddleheight > ball[2] - 4
        if ball[0] == 3
          ball[0] := 2
        if ball[0] == 4
          ball[0] := 1
      if ball[1] > xpix - 4
        ball[0] := 0
        p1f -= forceloss
      if ball[1] > xpix - 8 and p1 < ball[2] + 4 and p1 + paddleheight > ball[2] - 4
        if ball[0] == 1
          ball[0] := 4
        if ball[0] == 2
          ball[0] := 3
      if ball[2] < 4
        if ball[0] == 2
          ball[0] := 1
        if ball[0] == 3
          ball[0] := 4
      if ball[2] > ypix - 4
        if ball[0] == 1
          ball[0] := 2
        if ball[0] == 4
          ball[0] := 3       
      gr.pix(ball[1],ball[2],0,@boll)
    if p2f > xpix >> 1
      return 1
    if p1f > xpix >> 1
      return 2
    if tex > 0
      gr.color(3)
      gr.textmode(tex / 2,tex,6,%101)
      gr.text(xpix / 2,ypix / 2,nrs.dec(te2))
      tex--
      if tex < 1 and te2 > 0
        tex := charsze
        te2 --
      if tex < 1 and te2 == 0
        sp := gspeed
    gr.copy(bitmapp)
    waitcnt (tc + clkfreq / sp)
    'waitcnt(cnt + clkfreq / 100)
    
dat
ply           byte "Play 1 player",0
pl2p          byte "Play 2 players",0
lvl           byte "Level:"
lvlnr         byte "2",0
sett          byte "Settings",0
winner        byte "Player "
Winnernr      byte "1 win!",0
cpuwinner     byte "You lose!",0
youwinner     byte "You win!",0
Back          byte "Back",0
ChSpeed       byte "Change speed",0
ChSze         byte "Change size",0
Save          byte "Save settings",0
ScrSze        byte "Change screensize",0
charsze       byte 30
gspeed         byte 80
PaddleHeight  byte 19
scx           byte 4
scy           byte 4
DisableTime   byte 80
ForceLoss     byte 15

tvparams                long    0               'status
                        long    1               'enable
                        long    %10_111       'pins
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    xtiles         'hc
                        long    ytiles         'vc
                        long    4              'hx
                        long    4               'vx
                        long    0               'ho
                        long    0               'vo
                        long    512             'hd
                        long    10              'hf
                        long    75              'hs
                        long    43              'hb
                        long    480             'vd
                        long    11              'vf
                        long    2               'vs
                        long    31              'vb
                        long    0

boll    word
        byte 1,7,4,4
        word %%00222000
        word %%02222200
        word %%22222220
        word %%22222220
        word %%22222220
        word %%02222200
        word %%00222000
RBoll   word
        byte 1,7,4,4
        word %%00333000
        word %%03333300
        word %%33333330
        word %%33333330
        word %%33333330
        word %%03333300
        word %%00333000
        

splash word
        byte 16,95,0,0
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00011111, %%10000000, %%00000000, %%00100000, %%00111110, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00001000, %%01000000, %%00100010, %%01100000, %%00010001, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00001000, %%01000000, %%00100010, %%00100000, %%00010001, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00001000, %%01000110, %%01110111, %%00100011, %%00010001, %%00011100, %%01011000, %%01111100, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00001111, %%10001001, %%00100010, %%00100100, %%10011110, %%00100010, %%11100100, %%10001000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00001000, %%01000111, %%00100010, %%00100111, %%10010000, %%00100010, %%01000100, %%10001000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00001000, %%01001001, %%00100010, %%00100100, %%00010000, %%00100010, %%01000100, %%01110000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00001000, %%01001001, %%00101010, %%10100100, %%10010000, %%00100010, %%01000100, %%10000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00011111, %%10000111, %%10110011, %%01110011, %%00111000, %%00011100, %%11101110, %%11111000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%10000100, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%10000100, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%01111000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000000, %%33000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000003, %%33300000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000002, %%20000000, %%00000033, %%33330000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000033, %%33330000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000003, %%33300000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%33000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00222000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02222200, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%22222220, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%22222220, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%22222220, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02222200, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00222000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%02200000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000
word %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000, %%00000000